--[[=============================================================================
    Lua Action Code

    Copyright 2023 Key Digital Systems. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.actions = "2016.01.08"
end

-- TODO: Create a function for each action defined in the driver

function LUA_ACTION.TemplateVersion()
	TemplateVersion()
end

function LUA_ACTION.SetVideoPattern(tParams)
    print(string.format("===== Action: SetVideoPattern output %d - %s =====", tParams.Output, tParams.Pattern))
    local command = string.format("SPO%02dPG%01d", tParams.Output, tVideoPatternMap[tParams.Pattern])
    PackAndQueueCommand("SetVideoPattern", command)
end

function LUA_ACTION.SetVideoFormat(tParams)
    print(string.format("===== Action: SetVideoFormat output %d - %s =====", tParams.Output, tParams.Format))
    local command = string.format("SPO%02dVF%02d", tParams.Output, tVideoFormatMap[tParams.Format])
    PackAndQueueCommand("SetVideoFormat", command)
end

function LUA_ACTION.SetFrontPanel(tParams)
    print(string.format("===== Action: SetFrontPanel: %s =====", tParams.FrontPanel))
    local command = string.format("SPCFB%s", tEnableStateMap[tParams.FrontPanel])
	PackAndQueueCommand("SetFrontPanel", command)
end

function LUA_ACTION.ResetException()
    print("===== Action: ResetException =====")
    local command = "SPCDF00"
	PackAndQueueCommand("ResetException", command)
end

function LUA_ACTION.ResetAll()
    print("===== Action: ResetAll =====")
    local command = "SPCDF"
	PackAndQueueCommand("ResetAll", command)
end
