--[[=============================================================================
    Copyright 2023 Key Digital Systems. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.device_specific_commands = "2015.03.31"
end

--[[=============================================================================
    ExecuteCommand Code

    Define any functions for device specific commands (EX_CMD.<command>)
    received from ExecuteCommand that need to be handled by the driver.
===============================================================================]]

function EX_CMD.SwitchTo4x4Matrix(tParams)
    PackAndQueueCommand("SwitchTo4x4Matrix", "SPOOM0")
    if (tParams.ResetInputsAndOutputs == "True") then
        PackAndQueueCommand("SwitchTo4x4Matrix_Reset_1to1", "SPO01SI01")
        PackAndQueueCommand("SwitchTo4x4Matrix_Reset_2to2", "SPO02SI02")
        PackAndQueueCommand("SwitchTo4x4Matrix_Reset_3to3", "SPO03SI03")
        PackAndQueueCommand("SwitchTo4x4Matrix_Reset_4to4", "SPO04SI04")
    end
end

function EX_CMD.SetVideoWall_Mode(tParams)
    local command = string.format("SPOOM%01d", tVideoWallModeMap[tParams.Mode])
    PackAndQueueCommand("SetVideoWall_Mode", command)
end
